#import <objc/Object.h>

#define    NTKP_REVISION "NTK protocols R2.0alpha"


/*****************************************************************/
/* NTKPmessage protocol                                          */
/*****************************************************************/
@protocol NTKPmessage

- (const char *)channelID;
- (const char *)senderUName;
- (const char *)fromID;
- (unsigned int)traceNr;

@end


/*****************************************************************/
/* NTKPclientview protocol                                       */
/*****************************************************************/
@protocol NTKPclientview

- (const char *)clientUName;
- setClientUName:(const char *)aClientUName;
- (const char *)connectionCode;
- setConnectionCode:(const char *)aClientUName;
- setUserName:(const char *)aUserName;
- freeDocument:sender;

@end


/*****************************************************************/
/* NTKPclient protocol                                           */
/*****************************************************************/
@protocol NTKPclient

/* querying names from the client */
- (const char *)uniqueName;
- (const char *)clientName;
- (const char *)userName;
- (const char *)realUserName;

/* server starting -- hope this will soon get out of here */
- (BOOL)isServerStarter;
- (oneway void)setServerStarter:(BOOL)aFlag;

/* don't know why this is here */
- (id<NTKPclient>)sendDisconnectTo:(const char *)uName;
- (id<NTKPclient>)sendDisconnectTo:(const char *)uName
	forCode:(const char *)aCode;

/* information update messages */
- (oneway void)newClientNamed:(const char *)uName;

/* building a connection */
- (oneway void)
	client:(in const char *)uName 
		sendsVia:aServerText
		forCode:(const char *)aCode
		topicIs:(in const char *)aTopic;

/* disconnecting */
- (oneway void)
	client:(in const char *)uName
		refusesConnectionForCode:(const char *)aCode;
- (oneway void)
	client:(in const char *)uName
		wantsToDisconnectForCode:(const char *)aCode;

/* messaging */
//- (oneway void)message:(id<NTKPmessage>)aMessage;

@end


/*****************************************************************/
/* NTKPserver protocol                                           */
/*****************************************************************/
@protocol NTKPserver

/* querying server attibutes */

/* handling the client list */
- (id)clientList;
- (id<NTKPserver>)addClient:(in id<NTKPclient>)aClient;
- (id<NTKPserver>)removeClient:(in id<NTKPclient>)aClient;
- (id<NTKPclient>)findClientNamed:(const char *)uName;

/* building a connection */
- (oneway void)
	connect:(in id<NTKPclient>)aClient
		to:(in const char *)uName
		via:(in id)aServerText
		withCode:(in const char *)aCode
		topicIs:(in const char *)aTopic;

/* disconnecting */
- (oneway void)
	disconnect:(in id<NTKPclient>)aClient
		from:(in const char *)uName
		forCode:(in const char *)aCode;
- (oneway void)
	refuseConnection:(in id<NTKPclient>)aClient
		to:(in const char *)uName
		forCode:(in const char *)aCode;

@end


/*****************************************************************/
/* NTKPtrading protocol                                          */
/*****************************************************************/
@protocol NTKPtrading

- (const char *)hostList;
- (BOOL)setAlternateHostName:(const char *)hostName;

@end
